
%if %{?fedora}%{?rhel} >= 5
%define useselinux 1
%else
%define useselinux 0
%endif


Summary: Addons for the virtualization stack based on libvirt/KVM
Name: virt-stack
Version: 0.0.1
Release: 3
Source0: %{name}-%{version}.tar.gz
BuildArch: noarch
Patch0: virt-stack-0.0.1-virt_backup_default_dump.patch
Patch1: virt-stack-0.0.1-virt_backup_uses_cat_instead_of_dd.patch
Patch2: virt-stack-0.0.1-chmod_mapper_directory.patch
Patch3: virt-stack-0.0.1-lock_subsys.patch
Patch4: virt-stack-0.0.1-chown_ksm_to_kvm_group.patch
Patch5: virt-stack-0.0.1-set_umask_to_022.patch
Patch6: virt-stack-0.0.1-remove_savevm_init_script.patch
Patch7: virt-stack-0.0.1-virt-backup_unlock.patch
Patch8: virt-stack-0.0.1-ksmd.patch
Patch9: virt-stack-0.0.1-ksmd_ksmctl2devnull.patch
Patch10: virt-backup-0.0.1-fix_backup_dir_on_clean.patch
Patch11: virt-backup-0.0.1-fix_backup_dir_with_multiple_vm.patch
Patch12: virt-stack-0.0.1-virt-backup_cleanups.patch
#Patch13: virt-stack-0.0.1-logrotate_daemon_log.patch

License: GPL
Group: Virtualization
BuildRoot: %{_tmppath}/%{name}-buildroot
Prefix: %{_prefix}
Requires: libvirt => 0.8.2
Requires: python-virtinst
Requires: kvm
Requires: lvm2
Requires: util-linux
Requires: lzop, bzip2, pbzip2, gzip, xz
Requires: perl(Sys::Virt) => 0.2.3
Requires: perl(XML::Simple)
Requires: xmlstarlet

Requires(pre): shadow-utils
Requires(preun): initscripts, chkconfig
Requires(postun): initscripts
Requires(post): initscripts, chkconfig

%if %{useselinux}
BuildRequires: selinux-policy-devel
BuildRequires: checkpolicy
Requires: policycoreutils
%endif


AutoReq: no

%description
This package contains utilities for virtualization stack
on RHEL & ci. It provides for example a backup script
SELinux policy, hook script to set permissions on ressources files
etc...

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
#%patch13 -p1

%build
%if %{useselinux}
   # SElinux
   pushd selinux
   make -f %{_datadir}/selinux/devel/Makefile
   popd
%endif 

%install

%{__rm} -rf $RPM_BUILD_ROOT

# Install backup script
%{__mkdir_p} $RPM_BUILD_ROOT%{_bindir}/
%{__install} -m 0755 scripts/virt-backup $RPM_BUILD_ROOT%{_bindir}/

# Install libvirt hooks scripts
%{__mkdir_p} $RPM_BUILD_ROOT%{_sysconfdir}/libvirt/hooks
%{__install} -m 0755 scripts/hooks-daemon $RPM_BUILD_ROOT%{_sysconfdir}/libvirt/hooks/daemon
%{__install} -m 0755 scripts/hooks-qemu $RPM_BUILD_ROOT%{_sysconfdir}/libvirt/hooks/qemu

# Install SELinux module
%if %{useselinux}
%{__mkdir_p} $RPM_BUILD_ROOT%{_datadir}/selinux/packages/%{name}
%{__install} -m 644 selinux/%{name}.pp $RPM_BUILD_ROOT%{_datadir}/selinux/packages/%{name}/
%endif

# Install KSM init script
%{__mkdir_p} $RPM_BUILD_ROOT%{_initrddir}
%{__mkdir_p} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
%{__install} -m 0755 scripts/init-ksm $RPM_BUILD_ROOT%{_initrddir}/ksmd
%{__install} -m 644 conf/ksmd.conf $RPM_BUILD_ROOT%{_sysconfdir}/ksmd.conf

# Create backup dir
%{__mkdir_p} $RPM_BUILD_ROOT%{_localstatedir}/lib/libvirt/backup

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%pre
getent group kvm >/dev/null || groupadd -g 36 -r kvm
getent group qemu >/dev/null || groupadd -g 107 -r qemu
getent passwd qemu >/dev/null || \
  useradd -r -u 107 -g qemu -G kvm -d / -s /sbin/nologin \
    -c "qemu user" qemu

%preun
if [ $1 = 0 ]; then
  service ksm stop > /dev/null 2>&1 || :
  chkconfig --del ksm || :
fi

%post
%if %{useselinux}
(
# Install/update Selinux policy
semodule -i %{_datadir}/selinux/packages/%{name}/%{name}.pp
) &>/dev/null
%endif
chkconfig --add ksmd || :


%files
%defattr(-,root,root,-)
%{_bindir}/*
%{_sysconfdir}/libvirt/hooks/*
%{_initrddir}/*
%config(noreplace) %{_sysconfdir}/*.conf
%dir %attr(0770, qemu, kvm) %{_localstatedir}/lib/libvirt/backup
%if %{useselinux}
%{_datadir}/selinux/packages/%{name}/%{name}.pp
%endif

%changelog
* Mon Apr 04 2011 Daniel B. <daniel@firewall-services.com> - 0.0.1-3
- Remove logrotate conf (included in libvirt 0.9.0)

* Thu Jan 20 2011  Daniel B. <daniel@firewall-services.com> - 0.0.1-2
- Add libvirtd logrotate file

* Wed Nov 10 2010 Daniel B. <daniel@firewall-services.com> - 0.0.1-1
- Initial release

